<template src="./showInfoComponent.htm"></template>

<script>

    import ValidationErrorsMixin from '../../../../../mixins/validationErrorsMixin.js';

    export default {

        mounted() {

            eventBus.$on('entity-loaded', () => this.parseOrder())
        },

        data() {

            return {

                orderStatuses: [
                    {
                        value: 1,
                        label: 'Accepted'
                    },
                    {
                        value: 2,
                        label: 'Declined'
                    }
                ],

                customer: {},

                billing: {},

                final: {

                    status: null,

                    admin_comment: '',

                    final: 1
                }
            }
        },

        mixins: [ ValidationErrorsMixin ],

        methods: {

            /**
             * Call parse methods on order load.
             */
            parseOrder() {

                this.parseOrderFinal();
                this.parseBillingShippingInfo();
            },


            /**
             * Set billing and customer info after order is loaded.
             */
            parseBillingShippingInfo() {

                let billing     = this.$store.state.finalOrder.billing;
                let customer    = this.$store.state.finalOrder.customer;

                for (let key in customer) {

                    if (customer.hasOwnProperty(key)) {

                        this.$set(this.customer, key, customer[key]);
                    }
                }

                for (let key in billing) {

                    if (billing.hasOwnProperty(key)) {

                        this.$set(this.billing, key, billing[key]);
                    }
                }
            },


            /**
             * Set final attributes when order is loaded.
             */
            parseOrderFinal() {

                let final                   = this.$store.state.finalOrder.final;
                this.final.status           = final.status;
                this.final.admin_comment    = final.admin_comment;
                this.final.final            = final.final;
            }
        },

        watch: {

            /**
             * On each change update final info in store.
             */
            final: {

                handler(newFinal) {

                    this.$store.dispatch('setFinal', newFinal);
                },

                deep: true
            },

            /**
             * This event is watched in CreateProductsComponent.
             */
            'final.status'() {

                eventBus.$emit('order-status-changed', this.final.status);
            }
        }
    }

</script>